/******************************** { ********************************/
//
//	޲	: AT90S2333/4433
//	̧ٖ	: SLA.C
//	Ver.	: 1.0
//	e	: [d@p ̧
//			  EFAST_charge		; }[d
//			  ETRICKLE_charge	: ظُ[d
//	߲	: IAR icca90
//		: Asmund Saetre / Terje Frostad / Dietmar Koenig
//		: 2000N 2 2-dr[dQl݌vvɕύX
//			  2000N 518-ŏIAJ
//
/*****************************************************************************/

#include "Sla.h"														// drdl`

/* O\̌^錾 */

extern time_struct time;												// (b)S\

#ifdef DEBUG 
extern int term_value1;													// I1lSϐ
extern int term_value2;													// I2lSϐ
extern int charge_current_min;											// [ddŏlSϐ
extern int charge_current_max;											// [ddőlSϐ
#endif

void FAST_charge(void)													/* }[d */
{
    unsigned int temp				= 0;								// ƗpǏϐ
    unsigned char fast_finish_hour	= 0;								// }[dԎǏϐ
    unsigned char fast_finish_min	= 0;								// }[dԕǏϐ
    unsigned int fast_charge_volt	= 0;								// }[dd[ddǏϐ
    unsigned char last_min			= 0;								// 1oߔrpO񕪒lۑǏϐ [C]

	#ifdef DEBUG 
		term_value1 = 0;												// I1l
	#endif

	time.sec = 0;														// bϐ
	time.min = 0;														// ϐ
	time.hour = 0;														// ϐ
	time.t_count = 14456;												// 1bvl(7.3728MHz/510=14.456kHz(PWMg))

	temp = Battery(TEMPERATURE);										// drx擾
	if ((temp < MIN_TEMP_ABS) && (temp > MAX_TEMP_ABS) && (temp > MAX_TEMP_FAST))
	{																	/* x͈͓(:нW) */
		fast_finish_min = (time.min + MAX_TIME_FAST);					// Pʏ[d()擾
		fast_finish_hour = time.hour;									// Pʏ[d()
		while (fast_finish_min > 60)									/* 60֎␳ */
		{
			fast_finish_min = fast_finish_min - 60;						// P1ԕ␳
			fast_finish_hour++;											// Pʕ␳
		}

		OCR1 = 0;														// /1rl(PWM ON)
		TCCR1B = 0x01;													// /1OuȂN

		if ((CHKBIT(CHARGE_STATUS,FAST)) && (!(CHKBIT(CHARGE_STATUS,ERROR))))
		{																/* ُȂ̋}[d */
			do															/* K[ddݒ(ɂ₩Jn) */
			{
				temp = Battery(CURRENT);								// [dd擾 [C]
				if ((temp < (MAX_I_FAST-I_BUFFER)) && (OCR1 < 255))		// KdPWMő喢ŁA [C]
					OCR1++;												// PWM ONԑ(T/C1rl=+1)
				else if ((temp > (MAX_I_FAST-I_BUFFER)) && (OCR1 > 0))	// KdPWMŏȊOŁA [C]
					OCR1--;												// PWM ONԌ(T/C1rl=-1)
			} while (temp != (MAX_I_FAST-I_BUFFER));					// K[dd܂ŌJԂp
			fast_charge_volt = Battery(VOLTAGE);						// K[dd̏[ddl(=K[dd)擾 [ǉ]
		}

		while ((CHKBIT(CHARGE_STATUS,FAST)) && (!(CHKBIT(CHARGE_STATUS,ERROR))))
		{																/* ُȂ̋}[d */
			do															/* K[dd(ɂ₩Jn) */
			{
				temp = Battery(VOLTAGE);								// [dd擾
				if ((temp < fast_charge_volt) && (OCR1 < 255))			// KdPWMő喢ŁA [C]
					OCR1++;												// PWM ONԑ(T/C1rl=+1)
				else if ((temp > fast_charge_volt) && (OCR1 > 0))		// KdPWMŏȊOŁA [C]
					OCR1--;												// PWM ONԌ(T/C1rl=-1)
			} while (temp != fast_charge_volt);							// K[dd܂ŌJԂp

			/* ُ팟 */

			if ((time.hour == fast_finish_hour) && (time.min == fast_finish_min))
			{															/* }[dԌoߎ */
				Stop_PWM();												// PWM~
				SETBIT(TERMINATION,TIME_MAX);							// ԒߏI׸ސݒ
				SETBIT(CHARGE_STATUS,ERROR);							// [dُ׸ސݒ
				#ifdef DEBUG
					term_value1 = time.min;								// I1lɕPʒlݒ
					term_value2 = fast_finish_min;						// I2lɋ}[dԕlݒ
				#endif
			}

            temp = Battery(TEMPERATURE);								// drx擾
			if ( temp < MAX_TEMP_ABS)									/* x(:нW) */
			{
				Stop_PWM();												// PWM~
				SETBIT(TERMINATION,TEMP_MAX);							// xߏI׸ސݒ
				SETBIT(CHARGE_STATUS,ERROR);							// [dُ׸ސݒ
				#ifdef DEBUG
					term_value1 = temp;									// I1lɓdrxݒ
					term_value2 = MAX_TEMP_ABS;							// I2lɏ[dxݒ
				#endif
			}

			temp = Battery(CURRENT);									// [dd擾
			if ( temp < MAX_I_FAST)										/* [ddߎ */
			{
				Stop_PWM();												// PWM~
				SETBIT(TERMINATION,I_MAX);								// [ddI׸ސݒ
				SETBIT(CHARGE_STATUS,ERROR);							// [dُ׸ސݒ
				#ifdef DEBUG
					term_value1 = temp;									// I1lɏ[ddݒ
					term_value2 = MAX_I_FAST;							// I2lɏ[ddlݒ
				#endif
			}

			if (time.min != last_min)									/* (00b) */
			{
				last_min = time.min;									// lۑ
				temp = Battery(CURRENT);								// [dd擾
				if ( temp < MIN_I_FAST)									/* }[ddB [C] */
				{
					Stop_PWM();											// PWM~
					SETBIT(TERMINATION,I_MIN);							// [ddBI׸ސݒ
					CLRBIT(CHARGE_STATUS,FAST);							// }[d׸މ
					SETBIT(CHARGE_STATUS,TRICKLE);						// ظُ[d׸ސݒ
					#ifdef DEBUG
						term_value1 = temp;								// I1lɏ[ddݒ
						term_value2 = MIX_I_FAST;						// I2lɋ}[ddlݒ [C]
					#endif
				}
			}
		}
	}
	if(!(CHKBIT(CHARGE_STATUS,ERROR)))									/* x͈͊OُȂ */
	{
		if ((temp <= MAX_TEMP_ABS) || (temp <= MAX_TEMP_FAST))			/* xߎ(:нW) [C] */
		{
			SETBIT(CHARGE_STATUS,TEMP_MAX);								// drxI׸ސݒ [C]
			#ifdef DEBUG
				if (MAX_TEMP_ABS < MAX_TEMP_FAST)						// Ήx[dxȂA
					term_value2 = MAX_TEMP_ABS;							// I2lɐΏdrxlݒ
				else													// Ήx[dxȂA
					term_value2 = MAX_TEMP_FAST;						// I2lɏ[ddrxlݒ
			#endif
		}
		else if (temp >= MIN_TEMP_ABS)									/* xߎ(:нW) [C] */
		{
			#ifdef DEBUG
				term_value2 = MIN_TEMP_ABS;								// I2lɉdrxlݒ
			#endif
			SETBIT(TERMINATION,TEMP_MIN);								// drxI׸ސݒ
		}
		SETBIT(CHARGE_STATUS,ERROR);									// ُI׸ސݒ
		#ifdef DEBUG
			term_value1 = temp;											// I1lɓdrxݒ
		#endif
	}
}

void TRICKLE_charge(void)												/* ظُ[d */
{
	unsigned int temp = 0;												// ƗpǏϐ

	time.sec = 0;														// bϐ
	time.min = 0;														// ϐ
	time.hour = 0;														// ϐ
	time.t_count = 14456;												// 1bvl(7.3728MHz/510=14.456kHz(PWMg))

	OCR1 = 0;															// /1rl(PWM ON)
	TCCR1B = 0x01;														// /1OuȂN

	while ((CHKBIT(CHARGE_STATUS,TRICKLE)) && (!(CHKBIT(CHARGE_STATUS,ERROR))))
	{																	/* ُȂظُ[d */
		temp = Battery(TEMPERATURE);									// drx擾
		if ((temp < MIN_TEMP_ABS) && (temp > MAX_TEMP_ABS))				/* x͈͓(:нW) [C] */
		{
			do															/* K[ddݒ(ɂ₩Jn) */
			{
				temp = Battery(VOLTAGE);								// [dd擾
						if ((temp < VOLT_TRICKLE) && (OCR1 < 255))		// KdPWMő喢ŁA [C]
					OCR1++;												// PWM ONԑ(T/C1rl=+1)
						if ((temp > VOLT_TRICKLE) && (OCR1 > 0))		// KdPWMŏȊOŁA [C]
					OCR1--;												// PWM ONԌ(T/C1rl=-1)
			} while (temp != VOLT_TRICKLE);								// K[dd܂ŌJԂp
		}

		/* ُ팟 */

		temp = Battery(TEMPERATURE);									// drx擾 [ǉ]
		if (temp < MAX_TEMP_ABS)										/* xߎ(:нW) [C] */
		{
			SETBIT(CHARGE_STATUS,TEMP_MAX);								// xߏI׸ސݒ
			SETBIT(CHARGE_STATUS,ERROR);								// [dُ׸ސݒ [ǉ]
			#ifdef DEBUG
				term_value1 = temp;										// I1lɓdrxݒ [ǉ]
				term_value2 = MAX_TEMP_ABS;								// I2lɏ[dxݒ
			#endif
		}
		else if (temp > MIN_TEMP_ABS)									/* xߎ(:нW) [C] */
		{
			SETBIT(TERMINATION,TEMP_MIN);								// xߏI׸ސݒ
			SETBIT(CHARGE_STATUS,ERROR);								// [dُ׸ސݒ [ǉ]
			#ifdef DEBUG
				term_value1 = temp;										// I1lɓdrxݒ [ǉ]
				term_value2 = MIN_TEMP_ABS;								// I2lɏ[dxݒ
			#endif
		}
//		SETBIT(CHARGE_STATUS,ERROR);									// [Ĉߍ폜]
//		#ifdef DEBUG													// [Ĉߍ폜]
//			term_value1 = temp;											// [Ĉߍ폜]
//		#endif															// [Ĉߍ폜]
	}
}

